# Changelog

## [1.0.13][TREE_1_0_13]

[Full Changelog][CHANGES_1_0_13]

**Improvements**

- Refatoração de função que possuía parâmetros default entre parâmetros obrigatórios.
- Refatoração de códigos para melhor legibilidade e performance.

[TREE_1_0_13]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/tree/ALG_1.0.13
[CHANGES_1_0_13]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/compare/ALG_1.0.12...ALG_1.0.13

## [1.0.12][TREE_1_0_12]

[Full Changelog][CHANGES_1_0_12]

**Fixed bugs**

- Correção na rotina de utilizações do prato na semana, na ultima alteração estava validando `!diaSitu.includes('S')` mas deveria estar validando se nas utlizações nao foi definida uma semana em especifico (Ex. Toda quarta feira)

- Alteração na consideração de dias anteriores e posterioes (baseando agora no dia calendario ao inves de dias com comensais)

[TREE_1_0_12]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/tree/ALG_1.0.12
[CHANGES_1_0_12]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/compare/ALG_1.0.11...ALG_1.0.12

## [1.0.11][TREE_1_0_11]

[Full Changelog][CHANGES_1_0_11]

**Fixed bugs**

- Correção na rotina de 'removeExcludedPlates' em CardService.js para que ao filtrar pratos que não foram utilizados no dia anterior e posterior caso ao final da filtragem não tenha nenhum prato viável (com frequência a ser utilizada) retorna todos os pratos originais ao inves de retornar apenas os pratos na ultima filtragem.

**Improvements**

- Melhoria na rotina de priorização de grupos considerando além frequencia minima, passa a verificar se o grupo ja atingiu a minima e quanto falta para atingir a minima em ambos os grupos. Rotina implementada em 'priorizaGruposPoucoUtilizados' no CardService.js

[TREE_1_0_11]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/tree/ALG_1.0.11
[CHANGES_1_0_11]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/compare/ALG_1.0.10...ALG_1.0.11

## [1.0.10][TREE_1_0_10]

[Full Changelog][CHANGES_1_0_10]
**Fixed bugs**

- Correção no log 'precardData' que estava sendo sobrescrito não mantendo todos os pratos gerados no pre cardapio.

- Alterado na função 'generateDiaConfig' para tornar pratos combinantes como obrigatórios apenas quando a origem da combinação também está presente no dia.

- Realizada condicional em generatePreCard para tratar dias do cardápio onde pratosO são os pratos combinados (combinação da direita) e não há pratos combinantes (lado esquerdo da combinação).

- Realizado controle para possibilitar combinações parciais gerando buraco nas colunas que não puderam ser combinadas.

- Correção na verificação de obrigatoria do prato baseado no grupo. Anteriormente verificava apenas o dia na semana (Ex.: Obrigatório na quarta). Atualmente, verifica se há marcação de qual semana (Ex.: 1ª semana) o mesmo é obrigatório. Se houver tal marcação verifica se a semana e o dia em questão são obrigatórios. Caso não haja a marcação verifica apenas se o dia esta como obrigatório.

**Improvements**

- Remoção de console.logs e comentários desnecessários.

- Remoção de parametros passado para funções porem não utilizados.

[TREE_1_0_10]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/tree/ALG_1.0.10
[CHANGES_1_0_10]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/compare/ALG_1.0.9...ALG_1.0.10

## [1.0.9][TREE_1_0_9]

[Full Changelog][CHANGES_1_0_9]

**Fixed bugs**

- Correção na rotina de geração da configuração de pratos no dia, para o seguinte caso de teste:
  Caso uma coluna tenha 2 possibilidade de pratos, onde 1 desses pratos seja inserido no pre cardápio,
  a rotina de pre cardápio removia esse prato das possibilidades quando estava analisando dias anterior/posterior,
  ao prato inserido no pre cardapio.
  Com isso durante a geração do restante do cardápio, caso o dia que agora possui apenas 1 prato como possibilidade,
  não pudesse utiliza-lo (Ex.: frequencia semana utilizada) o dia ficava com 'buraco' não planejado.
  Para evitar isso, foi incluso trecho pra re-validar os pratos originais que ainda possuem frequência.

[TREE_1_0_9]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/tree/ALG_1.0.9
[CHANGES_1_0_9]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/compare/ALG_1.0.8...ALG_1.0.9

## [1.0.8][TREE_1_0_8]

[Full Changelog][CHANGES_1_0_8]

**Fixed bugs**

- Correção na rotina de trocar de pratos quando há repetição de grupo em dias consecutivos na semana. A rotina
  não considerava o dia anterior e posterior ao prato que iria ser realizada a troca.

- Correção na validação de obrigatoriedade do prato quando na CostReview é feita validações de troca por repetição de grupo
  em pratos que estão em uma Combinação. A rotina considerava que apenas grupos que estivessem parametrizados como obrigatórios
  e que estivesse obrigatório também em uma determinada ocorrência (Primeira semana, segunda semana, etc). Com isso ela não
  impedia troca de pratos envolvidos em uma combinação que estivessem em dias obrigatórios.

[TREE_1_0_8]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/tree/ALG_1.0.8
[CHANGES_1_0_8]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/compare/ALG_1.0.7...ALG_1.0.8

## [1.0.7][TREE_1_0_7]

[Full Changelog][CHANGES_1_0_7]

**Added**

- Inclusão de arquivo de validação de ingrediente (IngredientValidation.js) utilizado na revisão do cardápio (CostReview.js)

[TREE_1_0_7]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/tree/ALG_1.0.7
[CHANGES_1_0_7]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/compare/ALG_1.0.6...ALG_1.0.7

## [1.0.6][TREE_1_0_6]

[Full Changelog][CHANGES_1_0_6]

**Fixed bugs**

- Correção na rotina que valida os ingredientes utilizados tanto no dia quanto
  no dia anterior/posterior fazendo a mesma respeitar a parametrização de
  "Restrição de Repetição de Ingrediente".

- Correção na rotina de precard onde a mesma não preenchia o cardapio com
  determinados pratos mesmo os grupos possuindo "Utilização do Grupo na Semana"
  cadastro como Obrigatório em determinados dias. O problema acontecia devido a
  rotina verificar so preencher o cardápio caso o prato possuí-se frequencia de
  prato e a mesma fosse válida. Agora ele permite pratos sem frequencia ou que
  possuem frequencia e a mesma está valida.

**Improvements**

- Implementação de rotinas de validação posterior a geração do cardápio.
  Sendo elas:
  - CostReview.js: Responsável por revisar o cardápio tentando realizar trocas
    de pratos afim de mitigar o custo quando o mesmo está acima da meta.
  - AnalizaCardapio.js: Responsável por realizar trocas de pratos durante a
    semana vizando evitar que no mesmo dia e em dias consecutivos possua pratos de
    mesmo grupo. A rotina prioriza retirar pratos de mesmo grupo em um mesmo dia
    em detrimento a dias consecutivos quando não há possibilidade de ajustar ambos.

**Added**

- Inclusão do arquivo CHANGELOG.md no projeto.
- Inclusão de sub-pastas como Helper, Lib, Error, Review para inicio de refatoração do projeto.
- Inclusão de pasta rules para denotar regras do algoritmo.

[TREE_1_0_6]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/tree/ALG_1.0.6
[CHANGES_1_0_6]: http://gitlab.teknisa.com/tecfood/algoritmo-otimizador-de-cardapio/-/compare/ALG_1.0.5...ALG_1.0.6
